/*
*** Mapige ***
Авторы: Aurora [Russia], Scarface_slv

http://world-source.ru
**********************
Описание:
	Этот плагин создан облегчить жизнь Администраторам сервера в выборе карт. Плагин отображает весь имеющийся список карт, при выборе карты появляется под меню и возникает изображение этой карты, если вы активируете кнопку далее, то карта меняется. Плагин автоматичеси заполняет в свой список (mapigelist.txt) наименования всех карт расположенные в дирректории maps/.

**********************
Спасибо Вам:
Scarface_slv за помощь в создании меню!
theY4Kman за его старания, я позаимствовал часть кода для этого замечательного плагина, по авто заполнению листа!
Спасибо http://world-source.ru, лучший форум, связанный со скриптингом и всем что с этим связанно, тут всегда Вас рады видеть и готовы помочь! Спасибо за то что Вы есть.

**********************
Версии:
	1.0 January 31, 2013
	* First Public Release!

**********************
Cvarlist (default value):
	sm_auto_mapigelist	 1 = При каждой смене уровня, карты сверяются со списком, 0 = Сверяются только при первом запуске сервера.

Admin Commands:
	sm_mapige	 Команда вызывает меню плагина Mapige.
	sm_writemapigelist	 Команда сверяет и перезаписывает список карт в mapigelist.txt.
***********************/


#include <sourcemod>
#include <sdktools>
#include <smlib>

#pragma semicolon 1


enum OutputType {
	Output_Console = 0,
	Output_File = 1,
};

new bool:g_writeOnMapigeChange;
new Handle:g_MapigeMenu = INVALID_HANDLE;


public Plugin:myinfo = {

	name = "[ASP] Mapige, (ver. 1.0)",
	author = "Aurora [Russia], Scarface_slv",
	description = "Mapige меню отображает весь список карт с их изображением.",
	url = "http://world-source.ru",
};


public OnPluginStart() {

	RegAdminCmd("sm_mapige", Command_MapigeMap, ADMFLAG_CHANGEMAP, "Команда вызывает меню плагина Mapige");
	RegAdminCmd("sm_writemapigelist", WriteMapigeListCmd, ADMFLAG_GENERIC, "Команда сверяет и перезаписывает список карт в mapigelist.txt");
	new Handle:writeOnMapigeChange = CreateConVar("sm_auto_mapigelist", "0", "1 = При каждой смене уровня, карты сверяются со списком, 0 = Сверяются только при первом запуске сервера.");

	if (writeOnMapigeChange == INVALID_HANDLE) writeOnMapigeChange = FindConVar("sm_auto_mapigelist");
	HookConVarChange(writeOnMapigeChange, auto_mapigelistChanged);
	g_writeOnMapigeChange = GetConVarBool(writeOnMapigeChange);

	AutoExecConfig(true, "asp_mapige");
	PrintToServer("[Mapige] Loaded");
}

public OnMapStart() {

	g_MapigeMenu = BuildMapigeMenu();
	if (g_writeOnMapigeChange)
	{
		MapigeLister(Output_File, "mapigelist.txt", 0, "");
	}
}

/* Закрываем обработчик меню */
public OnMapEnd() {

	if (g_MapigeMenu != INVALID_HANDLE) {
		CloseHandle(g_MapigeMenu);
		g_MapigeMenu = INVALID_HANDLE;
	}
}

/* Записываем список в меню */
Handle:BuildMapigeMenu() {

	new Handle:file = OpenFile("mapigelist.txt", "rt");
	if (file == INVALID_HANDLE) {
		return INVALID_HANDLE;
	}
	new Handle:menu = CreateMenu(Menu_ViewImage);
	new String:mapname[255];
	while (!IsEndOfFile(file) && ReadFileLine(file, mapname, sizeof(mapname))) {
		if (mapname[0] == ';' || !IsCharAlpha(mapname[0])) {
			continue;
		}
		new len = strlen(mapname);
		for (new i=0; i<len; i++) {
			if (IsCharSpace(mapname[i])) {
				mapname[i] = '\0';
				break;
			}
		}
		if (!IsMapValid(mapname)) {
			continue;
		}
		AddMenuItem(menu, mapname, mapname);
	}
	CloseHandle(file);
	SetMenuTitle(menu, "Выберите Карту:");
	return menu;
}

/* Просматриваем изображение */
public Menu_ViewImage(Handle:menu, MenuAction:action, client, param2) {

	if (action == MenuAction_Select) {
		new Handle:mapigemenu = CreateMenu(Menu_ChangeMap);

		decl String:info[64];
		decl String:format[64];

		GetMenuItem(menu, param2, info, sizeof(info));
		SetMenuTitle(mapigemenu, "Продолжить?");
		Format(format, sizeof(format), "mapige/%s", info);
		SetOverlay(client, format);
		AddMenuItem(mapigemenu, info, "Продолжить");
		SetMenuExitBackButton(mapigemenu, true);
		DisplayMenu(mapigemenu, client, 0);
	}
}

/* Меняем карту */
public Menu_ChangeMap(Handle:menu, MenuAction:action, client, param2) {

	if (action == MenuAction_End) {
		CloseHandle(menu);
	}

	else if (action == MenuAction_Cancel) {
		if (param2 == MenuCancel_ExitBack) {
			Command_MapigeMap(client, 0);
		}
		CreateTimer(0.1, ResetOverlay, client);
	}

	if (action == MenuAction_Select) {
		decl String:info[64];
		decl String:format[64];
		GetMenuItem(menu, param2, info, sizeof(info));
		Format(format, sizeof(format), "%s", info);
		ServerCommand("changelevel %s", format);
	}
}

/* Проверяем Список на Валидность */
public Action:Command_MapigeMap(client, args) {

	if (g_MapigeMenu == INVALID_HANDLE) {
		PrintToConsole(client, "Файл mapigelist.txt не найден!");
		return Plugin_Handled;
	}
	DisplayMenu(g_MapigeMenu, client, MENU_TIME_FOREVER);
	return Plugin_Handled;
}

/* Устанавливаем Оверлей */
stock SetOverlay(client, String:overlay[]) {

	if(IsValidClient(client)) Client_SetScreenOverlay(client, overlay);
}

/* Сбрасываем Оверлей */
public Action:ResetOverlay(Handle:timer, any:client) {

	if(IsValidClient(client)) Client_SetScreenOverlay(client, "");
}

/* Проверяем на игроеп на Валидность */
stock IsValidClient(client) {

	if(IsClientConnected(client) && IsClientInGame(client)) return true;
	return false;
}

/*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*/
/* Особая благодарность за часть кода: */
/*	            theY4Kman 		       */
/*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*/
public auto_mapigelistChanged(Handle:convar, const String:oldValue[], const String:newValue[]) {
	g_writeOnMapigeChange = GetConVarBool(convar);
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max) {

	CreateNative("ListMapigesToClient", native_MapigeList);
	CreateNative("WriteNewMapigeList", native_WriteMapigeList);
	return APLRes_Success;
}

public native_MapigeList(Handle:plugin, numParams) {

	new client = GetNativeCell(1);
	if (client > GetMaxClients() || client < 0) return ThrowError("Client index %d is invalid", client);
	else if(!IsClientConnected(client)) return ThrowError("Client %d is not connected", client);
	decl String:filter[PLATFORM_MAX_PATH];
	filter[0] = '\0';
	if (numParams > 1) GetNativeString(2, filter, sizeof(filter));
	MapigeLister(Output_Console, "", client, filter);
	return true;
}

public native_WriteMapigeList(Handle:plugin, numParams) {

	decl String:filter[PLATFORM_MAX_PATH];
	filter[0] = '\0';
	if (numParams > 1) GetNativeString(2, filter, sizeof(filter));
	decl String:path[PLATFORM_MAX_PATH];
	GetNativeString(1, path, sizeof(path));
	return MapigeLister(Output_File, path, 0, filter);
}

public Action:WriteMapigeListCmd(client, args) {

	if (args > 2) {
		ReplyToCommand(client, "Too many arguments.");
		ReplyToCommand(client, "Usage: sm_writemapigelist <output file> [filter]");
		return Plugin_Handled;
	}
	decl String:filename[PLATFORM_MAX_PATH];
	decl String:filter[PLATFORM_MAX_PATH];
	filter[0] = '\0';
	if (args >= 1) GetCmdArg(1, filename, sizeof(filename));
	else strcopy(filename, sizeof(filename), "mapigelist.txt");
	if (args >= 2) GetCmdArg(2, filter, sizeof(filter));
	MapigeLister(Output_File, filename, client, filter);
	ReplyToCommand(client, "[Mapige] Generated a fresh mapigelist!");
	LogMessage("%L generated a fresh mapigelist in %s", client,	filename);
	return Plugin_Handled;
}

MapigeLister(OutputType:type, const String:path[], client, const String:filter[]) {

	new Handle:mapigelist;

	if (type == Output_File) {
		mapigelist = OpenFile(path, "w");
		if (mapigelist == INVALID_HANDLE) return false;
	}

	new Handle:mapigedir = OpenDirectory("maps/");
	if (mapigedir == INVALID_HANDLE) return false;
	decl String:name[PLATFORM_MAX_PATH];
	new Handle:array = CreateArray(PLATFORM_MAX_PATH/4);
	new FileType:filetype;
	new namelen;
	new filterlen = strlen(filter);
	new bool:exclude = false;
	decl String:fileMapige[PLATFORM_MAX_PATH];

	for (new i=0; i<2; i++) {
		while (ReadDirEntry(mapigedir, name, sizeof(name), filetype)) {
			if (filetype != FileType_File) continue;
			namelen = strlen(name) - 4;
			if (StrContains(name, ".bsp", false) != namelen) continue;
			name[namelen] = '\0';
			if (strncmp(filter, name, filterlen) != 0) exclude = true;
			if (strncmp(fileMapige, name, strlen(name)) == 0) {
				exclude = true;
				break;
			}
			if (!exclude) PushArrayString(array, name);
			exclude = false;
		}
		CloseHandle(mapigedir);
		mapigedir = OpenDirectory("addons/");
		if (mapigedir == INVALID_HANDLE) break;
	}
	CloseHandle(mapigedir);
	SortADTArray(array, Sort_Ascending, Sort_String);
	new i;
	new len = GetArraySize(array);
	for (i=0; i<len; i++) {
		GetArrayString(array, i, name, sizeof(name));
		if (type == Output_Console) PrintToConsole(client, "%s", name);
		else WriteFileLine(mapigelist, "%s", name);
	}
	if (type == Output_File) CloseHandle(mapigelist);
	else {
		if (len > 0) ReplyToCommand(client, "[Mapige] Mapige list printed to console.");
		else ReplyToCommand(client, "[Mapige] No mapiges found.");
	}
	return true;
}

